﻿using System;
using System.Drawing;
using System.Windows.Forms;
using ACLAS.Printer;

namespace PrinterDemo
{
    public partial class Form1 : Form
    {
        Bitmap PrnPage = null;
        int h;

        public Form1()
        {
            InitializeComponent();
        }

        private void btEnd_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void DrawString(Graphics gr, String s, String fname, Brush br, ref int y)
        {
            Font fn = new Font(fname, 28, FontStyle.Regular);
            if (AclasPrinter.Width == 576) 
                s = "TP33 Printer "+ s;
            gr.DrawString(s, fn, br, 0, y);
            y += 36;
            fn.Dispose();
        }

        private void DrawString12(Graphics gr, String s, String fname, Brush br, ref int y)
        {
            Font fn = new Font(fname, 12 , FontStyle.Regular);
            gr.DrawString(s, fn, br, 0, y);
            y += 20;
            fn.Dispose();
        }

        private int DrawPrinterPage()
        {
            int y = 0;
            Graphics gr = Graphics.FromImage(PrnPage);
            // Clear Page with white color
            gr.Clear(Color.White);
            Brush br = new SolidBrush(Color.Black);

            DrawString(gr, "Arial Font 28", "Arial", br, ref y);

            DrawString(gr, "Comic Sans MS 28", "Comic Sans MS", br, ref y);

            DrawString(gr, "Courier New 28", "Courier New", br, ref y);

            DrawString(gr, "Georgia Font 28", "Georgia", br, ref y);

            DrawString(gr, "Impact Font 28", "Impact", br, ref y);

            DrawString(gr, "Times New Roman 28", "Times New Roman", br, ref y);

            DrawString(gr, "Trebuchet MS 28", "Trebuchet MS", br, ref y);

            DrawString(gr, "Kino MT Font 28", "Kino MT", br, ref y);

            DrawString(gr, "Tahoma Font 28", "Tahoma", br, ref y);

            DrawString(gr, "Verdana Font 28", "Verdana", br, ref y);

            y += 10;
            DrawString12(gr, "Webdings Font", "Arial", br, ref y);
            DrawString(gr, "0123456789", "Webdings", br, ref y);

            y += 10;
            DrawString12(gr, "Wingdings Font", "Arial", br, ref y);
            DrawString(gr, "0123456789", "Wingdings", br, ref y);

            y += 10;
            DrawString12(gr, "Symbol Font", "Arial", br, ref y);
            DrawString(gr, "abcdefghijklmn 28", "Symbol", br, ref y);

            y += 10;
            DrawString12(gr, "Microsoft Logo", "Arial", br, ref y);
            DrawString(gr, "M", "Microsoft Logo", br, ref y);

            br.Dispose();
            gr.Dispose();
            return y;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Open Printer Driver
            if (!AclasPrinter.Open())
            {
                MessageBox.Show("Error! Open Printer Driver Error!");
                Close();
                return;
            }

            // Alloc Printer Page Height 1000 dot 
            PrnPage = AclasPrinter.SetPageSize(1000);

            pictureBox1.Width = AclasPrinter.Width;   

            // Draw test page
            h = DrawPrinterPage();

            // Show Print data to Pic Box
            pictureBox1.Image = PrnPage;
            pictureBox1.Invalidate();  
        }

        private void Form1_Closed(object sender, EventArgs e)
        {
            // Close Printer Driver
            AclasPrinter.Close(); 
        }

        private void btPrint_Click(object sender, EventArgs e)
        {
            // Send Bitmap to  Printer
            AclasPrinter.BmpToPrinter(h);

            // If this Printer have cutter
            if (AclasPrinter.HaveCutter)
            {
                // send Feed and Cut paper
                AclasPrinter.FullCutWithFeed(20);
            }

            // Start Printing
            AclasPrinter.Start();
            
            // Wait Until Done
            while (AclasPrinter.GetStatus() != PrnStatus.Done)
                Application.DoEvents();
        }
    }
}